 CPP3320:    PGM        PARM(&USRPRF &OUTPUT)
             /*         Display user profile list */
             /*         OUTPUT(*) means display via the subfile */
             /*         OUTPUT(*LIST) means display via the report */

             /*         Command processing program for DSPUSR */

             DCL        &OUTPUT *LGL 1

             DCL        &USRPRF *CHAR 10

             DCL        &SPCAUT *CHAR 100
             DCL        &MAXSTG *DEC  11
             DCL        &MAXSTGA *CHAR 11
             DCL        &PTYLMT *CHAR 1
             DCL        &INLPGM *CHAR 10
             DCL        &INLPGMLIB *CHAR 10
             DCL        &JOBD   *CHAR 10
             DCL        &JOBDLIB *CHAR 10
             DCL        &GRPPRF *CHAR 10
             DCL        &OWNER  *CHAR 10
             DCL        &GRPAUT *CHAR 10
             DCL        &ACTCDE *CHAR 15
             DCL        &MSGQ   *CHAR 10
             DCL        &MSGQLIB *CHAR 10
             DCL        &OUTQ   *CHAR 10
             DCL        &OUTQLIB *CHAR 10
             DCL        &TEXT   *CHAR 50

             DCL        &DATE *CHAR 8 VALUE('00/00/00')
             DCL        &TIME *CHAR 8 VALUE('00:00:00')
             DCL        &COUNTER  *DEC  5
             DCL        &COUNTERA *CHAR 5
             DCL        &BLANK10 *CHAR 10
             DCL        &BLANK11 *CHAR 11
             DCL        &BLANK   *CHAR 1
             DCL        &BLANK2  *CHAR 2

             DCLF       FILE(QADSPOBJ)

             MONMSG     MSGID(CPF0000)

             DSPOBJD    OBJ(&USRPRF.QSYS) OBJTYPE(*USRPRF) +
                          OUTPUT(*NONE) OUTFILE(USERS.QTEMP)

             OVRDBF     FILE(QADSPOBJ) TOFILE(USERS.QTEMP)
             PRINT      PRTDTA(&DATE *BCAT &TIME *CAT '     Q38 - +
                          User Profile List    ' *CAT 'CPP3310') +
                          SKIPB(01) HEADING(*YES *REPLACE)
             PRINT      PRTDTA('                               +
                          Summary Report') SPACEA(2) HEADING(*YES *ADD)
             PRINT      PRTDTA('User       Initial     +
                          Special                        Job         +
                          Output      Message    Accounting      +
                          Group      Group      Group') +
                          heading(*yes *add)
             PRINT      PRTDTA('Profile    Program     +
                          Authority                      Description +
                          Queue       Queue      Code            +
                          User       Owner      Authority') +
                          HEADING(*YES *ADD)

 GETDBF:     RCVF       RCDFMT(QLIDOBJD)
             MONMSG     MSGID(CPF0864) EXEC(GOTO ENDOFILE)
             RTVUSRPRF  USRPRF(&ODOBNM) RTNUSRPRF(&USRPRF) +
                          SPCAUT(&SPCAUT) MAXSTG(&MAXSTG) +
                          PTYLMT(&PTYLMT) INLPGM(&INLPGM) +
                          INLPGMLIB(&INLPGMLIB) JOBD(&JOBD) +
                          JOBDLIB(&JOBDLIB) GRPPRF(&GRPPRF) +
                          OWNER(&OWNER) GRPAUT(&GRPAUT) +
                          ACGCDE(&ACTCDE) MSGQ(&MSGQ) +
                          MSGQLIB(&MSGQLIB) OUTQ(&OUTQ) +
                          OUTQLIB(&OUTQLIB) TEXT(&TEXT)

             IF         (&MAXSTG *EQ -1) DO
             CHGVAR     VAR(&MAXSTGA) VALUE('*NOMAX')
             ENDDO
             ELSE       DO
             CHGVAR     VAR(&MAXSTGA) VALUE(&MAXSTG)
             ENDDO
             PRINT      PRTDTA(&USRPRF *CAT &BLANK *CAT &INLPGM *CAT +
                          &BLANK2 *CAT %SST(&SPCAUT 01 30) *CAT +
                          &BLANK *CAT &JOBD *CAT &BLANK2 *CAT &OUTQ +
                          *CAT &BLANK2 *CAT &MSGQ *CAT &BLANK *CAT +
                          &ACTCDE *CAT &BLANK *CAT &GRPPRF *CAT +
                          &BLANK *CAT &OWNER *CAT &BLANK *CAT +
                          &GRPAUT) SPACEA(1) SPACEB(1)
             PRINT      PRTDTA(&BLANK10 *CAT &BLANK2 *CAT &INLPGMLIB +
                          *CAT &BLANK *CAT %SST(&SPCAUT 31 30) *CAT +
                          &BLANK2 *CAT &JOBDLIB *CAT &BLANK2 *CAT +
                          &OUTQLIB *CAT &BLANK2 *CAT &MSGQLIB)
             CHGVAR     VAR(&COUNTER) VALUE(&COUNTER + 1) +
                          /* Count number of users */
             GOTO       GETDBF  /* Read next user profile record */

 ENDOFILE:   CHGVAR     VAR(&COUNTERA) VALUE(&COUNTER)

             PRINT      PRTDTA(&COUNTERA *BCAT 'User profiles +
                          processed.') SPACEB(2) CLOSE(*YES)
 ENDPGM:     ENDPGM
